/**
***     socketapp.hpp
***
***     Copyright (C) 2008 SophiaCradle Incorporated.
***     All rights reserved.
***
***     ̃\[XR[h̓G[XgbvATXyhȂǂ̏Ă܂B
***     ۂ̎gpɍۂẮAKvɉďǉĂB
***
**/

#ifndef __SOCKETAPP_HPP
#define __SOCKETAPP_HPP

#include <SophiaFramework.hpp>

SFMTYPEDEFCLASS(socketapp)
class socketapp : public SFYApplication {
    SFMSEALCOPY(socketapp)
private:
    SFXTCPSocket                    _socket;
    SFXAnsiStringStreamWriter       _writer;
    SFXAnsiStringStreamReader       _reader;
    SFXAnsiString                   _message;
    SFZTitleBevelFrameSmp           _frame;
    SFZWindowSmp                    _window;
    SFZMultipleTextLabelControlSmp  _label;
public:
    static SFCInvokerPtr Factory(Void);
private:
    explicit socketapp(Void) static_throws;
    virtual ~socketapp(Void);
    XANDLER_DECLARE_BOOLEVENT(OnKey)
    XALLBACK_DECLARE_SFXTCPSOCKET(OnConnect)
    XALLBACK_DECLARE_SFXSTREAMWRITER(OnWrite)
    XALLBACK_DECLARE_SFXSTREAMREADER(OnRead)
};

#endif // __SOCKETAPP_HPP //
